Option Explicit		'ver 1.9 beta


'      (  ;)
Dim Exts: Exts = "htm;html;txt"

'        
Dim PattSrc: PattSrc = "Regular.txt"

'     ? [true / false]
Dim IgnoreCase: IgnoreCase = true



Const TristateTrue = -1
Const TristateFalse = 0
Const ForReading = 1
Const ForWriting = 2

Dim aExts: aExts = Split(Exts, ";")

Dim oFSO: Set oFSO = CreateObject("Scripting.FileSystemObject")
Dim oRegEx: Set oRegEx = CreateObject("VBScript.Regexp")
Dim bUTF16, FileFormat, FileToProcess, sArg

oRegEx.IgnoreCase = IgnoreCase
oRegEx.Global = true
oRegEx.Multiline = false

Dim cur: cur = oFSO.GetParentFolderName(WScript.ScriptFullName)
Dim myLog
CreateLogFile oFSO.BuildPath(cur, "Replace - log.log")

' ,      =  
Dim Folder: Folder = cur
PattSrc = oFSO.BuildPath(cur, PattSrc)

'        ( 1  )
if WScript.Arguments.Count <> 0 then
	sArg = WScript.Arguments(0)
	if Left(sArg, 1) = """" then sArg = Mid(sArg, 2, Len(sArg) - 2) 'UnQuote
	if oFSO.FolderExists(sArg) then
		Folder = sArg
	elseif oFSO.FileExists(sArg) then
		FileToProcess = sArg
	else
		msgbox "ReplaceByRegular: /,    -  !"
		WScript.Quit 1
	end if
end if

'  c        
Dim Patterns(): redim Patterns(0)
Dim Replaces(): redim Replaces(0)
Dim s
Dim pos, i: i = 0
Dim direction: direction = false
Dim word1, word2, Encode
with oFSO.OpenTextFile(PattSrc, 1)
	Do Until .AtEndOfStream
		s = .ReadLine
		if len(s) <> 0 then '   
			direction = not direction	' true -  1-  (1- )
			pos = instr(s, "=")
			if pos <> 0 then s = mid(s, pos + 1) '    "="
			if direction then word1 = s else word2 = s
			if not direction then ' 2  
				word2 = ReplaceEscapes(word2)
				Patterns(i) = word1 'ANSI
				Replaces(i) = word2
				i = i + 1
				redim preserve Patterns(i)
				redim preserve Replaces(i)
				Patterns(i) = Recode(word1, "windows-1251", "utf-8")
				'if Patterns(i) <> Patterns(i - 1) then
					Replaces(i) = Recode(word2, "windows-1251", "utf-8")
					i = i + 1
					redim preserve Patterns(i)
					redim preserve Replaces(i)
				'end if
			end if
		end if
	Loop
	.Close
end with
if i > 0 then redim preserve Patterns(i-1)
if i > 0 then redim preserve Replaces(i-1)

if len(Patterns(0)) = 0 then msgbox "        !": WScript.Quit
if not oFSO.FolderExists(Folder) then msgbox " " & Folder & "  !": WScript.Quit

if Len(FileToProcess) <> 0 then
	ProcessFile oFSO.GetFile(FileToProcess)
else
	Dim oRoot: Set oRoot = oFSO.GetFolder(Folder)
	ProcessFolder oRoot
end if

WScript.Echo "."


Function ReplaceEscapes(sText)
	Dim sReturn: sReturn = sText
	if instr(1, sText, "\\", 1) <> 0 then sReturn = Replace(sReturn, "\\", "\", 1,-1,1)
	if instr(1, sText, "\^", 1) <> 0 then sReturn = Replace(sReturn, "\^", "^", 1,-1,1)
	if instr(1, sText, "\$", 1) <> 0 then sReturn = Replace(sReturn, "\$", "$", 1,-1,1)
	if instr(1, sText, "\*", 1) <> 0 then sReturn = Replace(sReturn, "\*", "*", 1,-1,1)
	if instr(1, sText, "\+", 1) <> 0 then sReturn = Replace(sReturn, "\+", "+", 1,-1,1)
	if instr(1, sText, "\?", 1) <> 0 then sReturn = Replace(sReturn, "\?", "?", 1,-1,1)
	if instr(1, sText, "\.", 1) <> 0 then sReturn = Replace(sReturn, "\.", ".", 1,-1,1)
	if instr(1, sText, "\|", 1) <> 0 then sReturn = Replace(sReturn, "\|", "|", 1,-1,1)
	if instr(1, sText, "\n", 1) <> 0 then sReturn = Replace(sReturn, "\n", vbLf, 1,-1,1)
	if instr(1, sText, "\r", 1) <> 0 then sReturn = Replace(sReturn, "\r", vbCr, 1,-1,1)
	if instr(1, sText, "\t", 1) <> 0 then sReturn = Replace(sReturn, "\\", vbTab, 1,-1,1)
	ReplaceEscapes = sReturn
End Function

Sub ProcessFolder(oFolder)
    'On Error Resume Next
    Dim oFile, oSubfolder

    If oFolder.Attributes AND &H600 Then Exit Sub '  
    
    For Each oFile In oFolder.Files
		ProcessFile oFile
    Next

    For Each oSubfolder In oFolder.Subfolders
        scanFolder oSubfolder '
    Next
End Sub

Sub ProcessFile(oFile)
	Dim fPath, content, contentNew, oMatches, oMatch, oldReplacePatt, sTMP

	  fPath = oFile.Path
	  '	      -        
	  if StrComp(fPath, WScript.ScriptFullName, 1) <> 0 AND StrComp(fPath, PattSrc, 1) <> 0 AND IsValidExtension(oFSO.GetExtensionName(fPath)) then
		
		bUTF16 = isFileUTF16(fPath)
		
		if bUTF16 then
			FileFormat = TristateTrue
		else
			FileFormat = TristateFalse
		end if
		
		with oFile.OpenAsTextStream(ForReading, FileFormat)
			if not .AtEndofStream then content = .ReadAll()
			.Close
		end with
		contentNew = content
		sTMP = ""
		For i = 0 to Ubound(Patterns)
			oRegEx.Pattern = Patterns(i)
			set oMatches = oRegEx.Execute(contentNew)
			if oMatches.Count > 0 then
				oldReplacePatt = Replaces(i)
				For Each oMatch in oMatches
					if instr(1, Replaces(i), "{{{utf8toANSI}}}", 1) <> 0 then
						Replaces(i) = Replace(Replaces(i), "{{{utf8toANSI}}}", "", 1, -1, 1)
						Replaces(i) = Replace(Replaces(i), "\@", Recode(oMatch, "utf-8", "windows-1251"), 1, -1, 1)
						's = Recode(oMatch, "utf-8", "windows-1251")
						s = oMatch '     (utf-8),     
						sTMP = sTMP & s & "   ->   " & Replaces(i) & vbNewLine
					elseif instr(1, Replaces(i), "{{{ANSItoUTF8}}}", 1) <> 0 then
						Replaces(i) = Replace(Replaces(i), "{{{ANSItoUTF8}}}", "", 1, -1, 1)
						Replaces(i) = Replace(Replaces(i), "\@", Recode(oMatch, "windows-1251", "utf-8"), 1, -1, 1)
						s = oMatch
						sTMP = sTMP & s & "   ->   " & Replaces(i) & vbNewLine
					elseif i mod 2 = 0 then
						' 0 - ANSI
						if instr(1, Replaces(i), "$$$file$$$", 1) <> 0 then
							sTMP = sTMP & oMatch & "   ->   " & Replace(Replaces(i), "$$$file$$$", oFile.Name) & vbNewLine
							Replaces(i) = Replace(Replaces(i), "$$$file$$$", Recode(oFile.Name, "windows-1251", "utf-8"))
						else
							sTMP = sTMP & oMatch & "   ->   " & Replaces(i) & vbNewLine
						end if
					else
						' 1 - utf-8
						if instr(1, Replaces(i), "$$$file$$$", 1) <> 0 then Replaces(i) = Replace(Replaces(i), "$$$file$$$", Recode(oFile.Name, "windows-1251", "utf-8"))
						s = oMatch & "   ->   " & Replaces(i)
						s = Recode(s, "utf-8", "windows-1251")
						sTMP = sTMP & s & vbNewLine
					end if
					contentNew = Replace(contentNew, oMatch, Replaces(i), 1,1,1)
				Next
				Replaces(i) = oldReplacePatt
				if i mod 2 = 0 then i = i + 1 '   UTF-8 ,      ANSI
			end if
		Next
		if contentNew <> content then	'  
			with oFile.OpenAsTextStream(ForWriting, FileFormat)
				on error resume next
				.Write contentNew
				if Err.Number <> 0 then 
					AddToLog " !!!    : " & oFile.Path & " (,  )"
				else
					AddToLog " >>>  : " & oFile.Path & vbNewLine & sTMP
				end if
				on error goto 0
				.Close
			end with
			'WriteToFile contentNew, fPath 'Byte data

		end if
	  end if
End Sub

Function Recode(text, srcCharset, destCharset) '    ANSI ->  UTF-8
	On Error Resume Next
    If text = vbNullString Then Recode = text: Exit Function
    With CreateObject("ADODB.Stream")
        .Type = 2     'text
        .Mode = 3
        .Open
        .Charset = destCharset
        .WriteText text
        .Flush
        .Position = 0
        .Charset = srcCharset
        '.Type = 1     'binary
		'if StrComp(destCharset, "utf-8", 1) = 0 then .Read (3)     'skip BOM
		'if StrComp(destCharset, "utf-16", 1) = 0 then .Read (2)     'skip BOM
        'Recode = ByteArrayToString(.Read)
		Recode = .ReadText
		if Err.Number <> 0 then
			Recode = text
		else
			if StrComp(destCharset, "utf-8", 1) = 0 then Recode = mid(Recode,4)     'skip BOM
			if StrComp(destCharset, "utf-16", 1) = 0 then Recode = mid(Recode,3)     'skip BOM
		end if
        .Close
    End With
End Function

Function IsValidExtension(Extension) '        
	Dim myExt
	IsValidExtension = false
	For each myExt in aExts
		if StrComp(Extension, myExt, 1) = 0 then IsValidExtension = true: Exit For
	Next
End Function

Sub CreateLogFile(sFile)
	set myLog = oFSO.OpenTextFile(sFile, 2, True)
	myLog.Write Chr(&HFF) & Chr(&HFE)	' utf-16 BOM
End Sub

Function AddToLog(sLine) ' ANSI -> utf-16
	myLog.Write Recode(sLine & vbNewLine, "windows-1251", "utf-16")
End Function

Function WriteToFile(varStr, file)
    With CreateObject("ADODB.Stream")
		.Type = 2: .Open: .Position = 0
		.WriteText varStr
		'StringToByteArray(varStr)
		on error resume next
		.SaveToFile file, 2: .Close
		if Err.Number <> 0 then WScript.Echo ("No rights for creating logfile in current folder. " & file): Exit Function
	end with
	WriteArrayToFile = true
End function

'Function StringToByteArray(sText)
'    Dim BS: Set BS = CreateObject("ADODB.Stream")
'    BS.Type = 1 'adTypeBinary
'    BS.Open
'    Dim TS: Set TS = CreateObject("ADODB.Stream")
'    With TS
'        .Type = 2: .Open: .Charset = "iso-8859-1" ' need to check it !!!
'		.WriteText sText: .Position = 0: .CopyTo BS: .Close
'    End With
'    BS.Position = 0: StringToByteArray = BS.Read()
'    BS.Close: Set BS = Nothing: Set TS = Nothing
'End Function

'Function WriteArrayToFile(arr, file)
'	Dim varStr
'	'    
'    With CreateObject("ADODB.Stream")
'		.Type = 1: .Open: .Position = 0
'		varStr = join(arr, vbCrLf)
'		.Write StringToByteArray(varStr)
'		on error resume next
'		.SaveToFile file, 2: .Close
'		if Err.Number <> 0 then WScript.Echo ("No rights for creating logfile in current folder. " & file): Exit Function
'	end with
'	WriteArrayToFile = true
'End function

Function ByteArrayToString(varByteArray)
    Dim rs: Set rs = CreateObject("ADODB.Recordset")
    rs.Fields.Append "temp", 201, LenB(varByteArray) 'adLongVarChar
    rs.Open: rs.AddNew: rs("temp").AppendChunk varByteArray: rs.Update
	ByteArrayToString = rs("temp"): rs.Close: Set rs = Nothing
End Function

Function isFileUTF16(sFile)
	isFileUTF16 = false
	With CreateObject("ADODB.Stream")
		.Type = 1
		.Open
		.LoadFromFile sFile
		if .Size > 2 then
			s = ByteArrayToString(.Read(2))
			'is UTF-16LE BOM ?
			if Hex(Asc(Mid(s,1,1))) = "FF" And Hex(Asc(Mid(s,2,1))) = "FE" then
				isFileUTF16 = true
			end if
		end if
		.Close
	End With
End Function